
#include <memory>

#define SS_CRYPTER_DECRYPTER
#include "CryptString.h"

CryptString::CryptString(const char *str)
: m_buf( NULL )
{
	int size = 0;
	while ( true ) {
		if ( memcmp(str + size, sign_str_end, sizeof(sign_str_end)) == 0 ) {
			break;
		}
		size++;
	}
	m_buf = new char[size];
	memcpy( m_buf, str, size );
	for ( int i = 0; i < size; i++ ) {
		m_buf[i] ^= STRING_CRYPT_X;
	}
	m_size = size;
}

CryptString::~CryptString()
{
	if ( m_buf != NULL ) {
		memset( m_buf, 0, m_size );
		*(volatile char*)m_buf = *(volatile char*)m_buf;
		delete m_buf;
	}
}

CryptString::operator char *()
{
	return m_buf;
}